library xpath;

uses
  SysUtils,
  xmls, strs, WinSock;

{$R *.RES}

type
 TBLOb = record
  GetSegment: function(Handle: Pointer; Buffer: PChar;
  MaxLength: integer; var ReadLength: integer): WordBool; cdecl;
  Handle: Pointer; // BLOb handle
  SegCount, // Number of BLOb segments
  MaxSegLength, // Max length of BLOb segment
  TotalLength: integer; // Total BLOb length
  PutSegment: procedure(Handle: Pointer; Buffer: PChar;
  Length: integer); cdecl;
  // Seek: function: integer; cdecl; //
end;


const MaxBLOBPutlength=80;
      MaxVarCharLength = 32767;

function FillBuffer(var BLOb: TBLOb; Buf: PChar; FreeBufLen: Integer;
var ReadLen: Integer): Boolean;
var
  EndOfBLOb: Boolean;
  FreeBufLenX, GotLength: integer;
begin
  EndOfBLOB:=false;
  try
    ReadLen := 0;
    repeat
      GotLength := 0; { !?! }

      if FreeBufLen > MaxBLObPutLength then FreeBufLenX := MaxBLObPutLength
      else FreeBufLenX := FreeBufLen;

      with BLOb do
        EndOfBLOb := not GetSegment(Handle, Buf + ReadLen, FreeBufLenX, GotLength);

      Inc(ReadLen, GotLength);
      Dec(FreeBufLen, GotLength);
    until EndOfBLOb or (FreeBufLen = 0);
  except end;
  Buf[ReadLen] := #0;
  Result := EndOfBLOb;
end;

procedure XPath1(var BLOb: TBLOb; Path:pchar; CString:pchar); cdecl; export;
var XN: TXMLNode; ReadLength: Integer; Buf:pchar;
begin
  try
    CString[0] := #0;
    with BLOb do
      if (not Assigned(Handle)) or (TotalLength = 0) then Exit;
    GetMem(Buf, BLOb.TotalLength+2);
    Buf[BLOb.TotalLength]:=#0;
    try
     FillBuffer(BLOb, Buf, MaxVarCharLength - 1, ReadLength);
      XN:=TXMLNode.Create(Buf);
      try
       StrpCopy(CString, XN.Node[path]);
      finally XN.Free end;
    finally FreeMem(Buf) end;
  except end;
end;

exports Xpath1;

end.
